#include <Servo.h>
#include "Wire.h"       
#include "I2Cdev.h"     
#include "MPU6050.h"
#define enA 3
#define Ain1 2
#define Ain2 4
#define enB 6
#define Bin1 5
#define Bin2 7
#define trig 9
#define echo 10

float duration, distance;


Servo myservo;  // create servo object to control a servo

int pos = 0;    // variable to store the servo position

MPU6050 mpu;
int16_t ax, ay, az;
int16_t gx, gy, gz;

struct MyData {
  byte X;
  byte Y;
  byte Z;
};

MyData data;


void setup() {                                                                                                                                                                                                                                    
    Serial.begin(9600);
    pinMode(trig, OUTPUT);
    pinMode(echo, INPUT);
    pinMode(enA, OUTPUT);
    pinMode(Ain1, OUTPUT);
    pinMode(Ain2, OUTPUT);
    digitalWrite(Ain1, LOW);
    digitalWrite(Ain2, LOW);
    pinMode(enB, OUTPUT);
    pinMode(Bin1, OUTPUT);
    pinMode(Bin2, OUTPUT);
    digitalWrite(Bin1, LOW);
    digitalWrite(Bin2, LOW);

  myservo.attach(11);  // attaches the servo on pin 9 to the servo object
  Serial.begin(9600);
  Wire.begin();
  mpu.initialize();
  //pinMode(LED_BUILTIN, OUTPUT);
}

void loop() {

    digitalWrite(trig, LOW);
    delayMicroseconds(2);
    digitalWrite(trig, HIGH);
    delayMicroseconds(10);
    digitalWrite(trig, LOW);
    duration = pulseIn(echo,HIGH);
    distance = (duration*0.0343)/2;
    delay(50);
    if (distance < 20){sharpturn();}
    else {
    forward();
    }

  mpu.getMotion6(&ax, &ay, &az, &gx, &gy, &gz);
  data.X = map(ax, -17000, 17000, 0, 255 ); // X axis data
  data.Y = map(ay, -17000, 17000, 0, 255); 
  data.Z = map(az, -17000, 17000, 0, 255);  // Y axis data
  delay(50);

  if (data.Z < 20 || data.Z >35){movearm();}
  else {myservo.write(125); }

}
/*void armnormal(){

  delay(50);
  for (pos = 125; pos >= 0; pos -= 1) { // goes from 125 degrees to 0 degrees
    myservo.write(pos);              // tell servo to go to position in variable 'pos'
    delay(30);                       // waits 30ms for the servo to reach the position
  }
  delay(50);

}*/
void movearm(){
  
  for (pos = 0; pos <= 120; pos += 1) { // goes from 0 degrees to 125 degrees
    // in steps of 1 degree
    myservo.write(pos);              // tell servo to go to position in variable 'pos'
    delay(60); } 
  for (pos = 120; pos >= 0; pos -= 1) { // goes from 125 degrees to 0 degrees
    myservo.write(pos);              // tell servo to go to position in variable 'pos'
    delay(60); }  
  delay(50); 

   
  
  myservo.write(pos);
  delay(4000);

}

void forward() {
    analogWrite(enA, 70);
    digitalWrite(Bin1, HIGH);
    digitalWrite(Bin2, LOW);
    analogWrite(enB, 70);
    digitalWrite(Ain1, LOW);
    digitalWrite(Ain2, HIGH);
    delay(500);
}
void backwards() {
    analogWrite(enA, 70);
    digitalWrite(Ain1, LOW);
    digitalWrite(Ain2, HIGH);
    analogWrite(enB, 70);
    digitalWrite(Bin1, HIGH);
    digitalWrite(Bin2, LOW);
    delay(500);
}
void sharpturn(){
    analogWrite(enA, 70);
    digitalWrite(Ain1, LOW);
    digitalWrite(Ain2, HIGH);
    analogWrite(enB, 70);
    digitalWrite(Bin1, LOW);
    digitalWrite(Bin2, HIGH);
    delay(500);
}
